// MandelAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MandelApp.h"
#include "MandelAppDlg.h"

#include "mandel.h"

#include "stdlib.h"
#include "memory.h"
#include "math.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMandelAppDlg dialog

CMandelAppDlg::CMandelAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMandelAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMandelAppDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  m_pdcMemory = new CDC;
  m_pBitmap = new CBitmap;

  m_pProgressDialog = new ProgressDialog(pParent);

}

void CMandelAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMandelAppDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMandelAppDlg, CDialog)
	//{{AFX_MSG_MAP(CMandelAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDZOMMIN, OnZommIn)
	ON_BN_CLICKED(IDZOOMOUT, OnZoomOut)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMandelAppDlg message handlers

BOOL CMandelAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  CRect rectClient;
  unsigned long thread_id;

  m_isSelected = FALSE;
  m_startZoomPoint.x = 0;
  m_startZoomPoint.y = 0;
  m_endZoomPoint = m_startZoomPoint;

  x1 = -1.0;
  x2 = 2.0;

  y1 = 1.5;
  y2 = -1.5;

  m_count = 0;

  GetClientRect(rectClient);

  if(m_pdcMemory->GetSafeHdc() == NULL) {
    CClientDC dc(this);
    OnPrepareDC(&dc);

    BITMAP bitmap_att;

    m_pdcMemory->CreateCompatibleDC(&dc);
    m_pBitmap->CreateCompatibleBitmap(&dc,rectClient.right,rectClient.bottom);

    m_pBitmap->GetBitmap(&bitmap_att);

    m_pdcMemory->SelectObject(m_pBitmap);

    m_pdcMemory->SetMapMode(MM_ISOTROPIC);

    m_pdcMemory->SetWindowExt(RESOLUTION,RESOLUTION);
    m_pdcMemory->SetViewportExt(rectClient.right, rectClient.bottom);
    m_pdcMemory->SetViewportOrg(rectClient.left,rectClient.top);

    
//----------------- MPI Initialization ---------------------------------
    int provided;
    MPI_Init_thread(NULL,NULL,MPI_THREAD_MULTIPLE,&provided);

    MPI_Comm_rank(MPI_COMM_WORLD,&m_myRank);

    MPI_Comm_size(MPI_COMM_WORLD,&m_compSize);

//----------------- MPI Initialization ---------------------------------

    Mandel_SetupType();

//----------------- Create Worker thread -------------------------------

    if((m_hworker_thread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)MandelWorkerThread,NULL,(DWORD)0, &thread_id))==NULL) {      
      MPI_Finalize();
      ::MessageBox(NULL,"Error creating worker thread!","WMPI Mandelbrot Example",0);
      exit(0);
    }

//----------------- Create Worker thread -------------------------------

    GenerateMandel();
  }
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMandelAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMandelAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);

    OnPrepareDC(&dc);

    CRect rectUpdate;
    CRect clientRect;

    if(m_count > 10000) {
      ::MessageBox(NULL,"MERDA","",0);
    } 
    m_count++;

    dc.GetClipBox(&rectUpdate);

    GetClientRect(&clientRect);    

    if(dc.BitBlt(0,0,RESOLUTION,RESOLUTION,
      m_pdcMemory,0,0,SRCCOPY) == 0) {
      ::MessageBox(NULL,"Error Painting","MPI Mandlebrot Example",0);
    }

    if(m_isSelected && m_startZoomPoint != m_endZoomPoint) {
      dc.SelectStockObject(WHITE_PEN);
      dc.SelectStockObject(NULL_BRUSH);

      CPoint left, right;

      if(m_endZoomPoint.x < m_startZoomPoint.x) {
        left.x = m_endZoomPoint.x;
        right.x = m_startZoomPoint.x;        
      } else {
        left.x = m_startZoomPoint.x;
        right.x = m_endZoomPoint.x;
      }
      if(m_endZoomPoint.y < m_startZoomPoint.y) {
        left.y = m_endZoomPoint.y;
        right.y = m_startZoomPoint.y;
      } else {
        left.y = m_startZoomPoint.y;
        right.y = m_endZoomPoint.y;
      }
      
      dc.Rectangle(left.x,left.y, right.x, right.y);
    }
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMandelAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMandelAppDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonDown(nFlags, point);

  CClientDC dc(this);
	OnPrepareDC(&dc);

  CPoint left, right;
  CPoint cstart, cend;

  cstart = m_startZoomPoint;
  cend = m_endZoomPoint;

  dc.LPtoDP(&cstart);
  dc.LPtoDP(&cend);

  if(cend.x < cstart.x) {
    left.x = cend.x;
    right.x = cstart.x;        
  } else {
    left.x = cstart.x;
    right.x = cend.x;
  }
  if(cend.y < cstart.y) {
    left.y = cend.y;
    right.y = cstart.y;
  } else {
    left.y = cstart.y;
    right.y = cend.y;
  }

  left.x -= 20;
  left.y -= 20;

  right.x += 20;
  right.y += 20;

  CRect drawRect(left,right);

  InvalidateRect(drawRect,FALSE);

  m_startZoomPoint = point;
  dc.DPtoLP(&m_startZoomPoint);

  m_endZoomPoint = m_startZoomPoint;
  SetCapture();

  m_isSelected = TRUE;

  ::SetCursor(::LoadCursor(NULL,IDC_CROSS));

}

void CMandelAppDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonUp(nFlags, point);

  if(m_isSelected) {
    m_isSelected = FALSE;
    ::ReleaseCapture();
  }

}

void CMandelAppDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);

  if(m_isSelected) {
    CPaintDC dc(this);
    OnPrepareDC(&dc);

    CPoint cstart = m_startZoomPoint;
    CPoint cend = m_endZoomPoint;

    dc.LPtoDP(&cstart);
    dc.LPtoDP(&cend);

    CPoint left, right;

    if(cend.x < cstart.x) {
      left.x = cend.x;
      right.x = cstart.x;        
    } else {
      left.x = cstart.x;
      right.x = cend.x;
    }
    if(cend.y < cstart.y) {
      left.y = cend.y;
      right.y = cstart.y;
    } else {
      left.y = cstart.y;
      right.y = cend.y;
    }

    left.x -= 20;
    left.y -= 20;

    right.x += 20;
    right.y += 20;

    CRect drawRect(left,right);

    InvalidateRect(drawRect,FALSE);

    m_endZoomPoint = point;

    dc.DPtoLP(&m_endZoomPoint);
  }
}

void CMandelAppDlg::OnZommIn() 
{
	// TODO: Add your control notification handler code here

  double aux_x1, aux_x2;
  double aux_y1, aux_y2;
 
  if(m_startZoomPoint != m_endZoomPoint) {

    ::SetCursor(::LoadCursor(NULL,IDC_WAIT));

    if(m_endZoomPoint.x < m_startZoomPoint.x) {
      int start_pos = m_startZoomPoint.x;
      m_startZoomPoint.x = m_endZoomPoint.x;
      m_endZoomPoint.x = start_pos;
    }
    if(m_endZoomPoint.y < m_startZoomPoint.y) {
      int start_pos = m_startZoomPoint.y;
      m_startZoomPoint.y = m_endZoomPoint.y;
      m_endZoomPoint.y = start_pos;
    }
/*    if(m_endZoomPoint.x - m_startZoomPoint.x > m_endZoomPoint.y - m_startZoomPoint.y) {
      m_endZoomPoint.y += ((m_endZoomPoint.x - m_startZoomPoint.x) - (m_endZoomPoint.y - m_startZoomPoint.y))/2;
      m_startZoomPoint.y -= ((m_endZoomPoint.x - m_startZoomPoint.x) - (m_endZoomPoint.y - m_startZoomPoint.y))/2;
    } else {
      m_endZoomPoint.x += ((m_endZoomPoint.y - m_startZoomPoint.y) - (m_endZoomPoint.x - m_startZoomPoint.x))/2;
      m_endZoomPoint.x -= ((m_endZoomPoint.y - m_startZoomPoint.y) - (m_endZoomPoint.x - m_startZoomPoint.x))/2;
    }*/
    aux_x1 = x1;
    aux_x2 = x2;
    x1 = aux_x1 + (double) m_startZoomPoint.x * fabs(aux_x2 - aux_x1) / RESOLUTION;
    x2 = aux_x1 + (double) m_endZoomPoint.x * fabs(aux_x2 - aux_x1) / RESOLUTION;

    aux_y1 = y1;
    aux_y2 = y2;
    y1 = aux_y1 - (double) m_startZoomPoint.y * fabs(aux_y1 - aux_y2) / RESOLUTION;
    y2 = aux_y1 - (double) m_endZoomPoint.y * fabs(aux_y1 - aux_y2) / RESOLUTION;

    aux_x1 = x1;
    aux_x2 = x2;
    aux_y1 = y1;
    aux_y2 = y2;

    if(fabs(x2-x1) > fabs(y1-y2)) {
      y1 += (fabs(aux_x2-aux_x1) - fabs(aux_y1-aux_y2))/2;
      y2 -= (fabs(aux_x2-aux_x1) - fabs(aux_y1-aux_y2))/2;
    } else {
      x1 -= (fabs(aux_y1-aux_y2) - fabs(aux_x2-aux_x1))/2;
      x2 += (fabs(aux_y1-aux_y2) - fabs(aux_x2-aux_x1))/2;
    }

    CClientDC dc(this);
		OnPrepareDC(&dc);

    GenerateMandel();

    m_startZoomPoint = m_endZoomPoint;

    InvalidateRect(CRect(0,0,RESOLUTION,RESOLUTION),FALSE);

    ::SetCursor(::LoadCursor(NULL,IDC_CROSS));

  }
}

void CMandelAppDlg::OnZoomOut() 
{
	// TODO: Add your control notification handler code here

  ::SetCursor(::LoadCursor(NULL,IDC_WAIT));

	x1 = x1 - fabs(x2 - x1);
  x2 = x2 + fabs(x2 - x1);

  y1 = y1 + fabs(y1 - y2);
  y2 = y2 - fabs(y1 - y2);

  CClientDC dc(this);
	OnPrepareDC(&dc);

  GenerateMandel();

  InvalidateRect(CRect(0,0,RESOLUTION,RESOLUTION),FALSE);

  ::SetCursor(::LoadCursor(NULL,IDC_CROSS));
}

void CMandelAppDlg::OnPrepareDC(CDC *pDC)
{
  
  CRect rectClient;

  GetClientRect(rectClient);

  pDC->SetMapMode(MM_ISOTROPIC);
  pDC->SetWindowExt(RESOLUTION,RESOLUTION);
  pDC->SetViewportExt(rectClient.right, rectClient.bottom);
  pDC->SetViewportOrg(rectClient.left,rectClient.top);

}

void CMandelAppDlg::GenerateMandel()
{

  int proc, proc_rank;
  int *proc_size_y;
  int *proc_start_y;

  int tasks_sent=0;
  int tasks_recvd=0;

  MandelInfo info;
  MPI_Status status;
  
  short *values;
  int buffer_size;

  
//  CString time_used;

//  double start_time = MPI_Wtime();
//  double end_time;

  int layers = 2;
  int shunk_size = (RESOLUTION / (m_compSize * layers));

  double dy = fabs(y1-y2) / (m_compSize*layers);
  double dpoint = fabs(y1-y2) / RESOLUTION;

  if(!m_pProgressDialog->Create(m_compSize * layers)) {
    ::MessageBox(NULL,"Error creating dialog","",0);
  }

  m_pProgressDialog->ShowWindow(SW_SHOW);

  proc_size_y = (int *) malloc(m_compSize*sizeof(int));
  proc_start_y = (int *) malloc(m_compSize*sizeof(int));

  info.x1 = x1;
  info.x2 = x2;
  info.size_x = RESOLUTION;
  info.size_y = shunk_size;
  info.stop = 0;

//----------------- Work Distribution and results gathering -----------

  for(proc = 0; proc< m_compSize; proc++) {
    info.y1 = y1 - ((double) proc * dy);
    info.y2 = y1 - ((double) (proc + 1) * dy) - dpoint;
    MPI_Send(&info,1, MandelInfoType, proc, MANDEL_TAG_INFO, MPI_COMM_WORLD);
    proc_size_y[proc] = info.size_y;
    proc_start_y[proc] = proc * shunk_size;
    tasks_sent++;
  }

  buffer_size = shunk_size*info.size_x;
  values = (short *) malloc(buffer_size*sizeof(short));

  while(tasks_sent!=m_compSize*layers) {
    MPI_Recv(values, buffer_size, MPI_SHORT, MPI_ANY_SOURCE, MANDEL_TAG_DEEPTABLE, MPI_COMM_WORLD, &status);

    proc_rank = status.MPI_SOURCE;

    PrintMandel(proc_size_y[proc_rank], proc_start_y[proc_rank], values);

    m_pProgressDialog->MoveProgress();

    tasks_recvd++;

    info.y1 = y1 - (double) tasks_sent * dy;
    info.y2 = y1 - (double) (tasks_sent + 1) * dy - dpoint;

    MPI_Send(&info,1, MandelInfoType, proc_rank, MANDEL_TAG_INFO, MPI_COMM_WORLD);
    
    proc_size_y[proc_rank] = info.size_y;
    proc_start_y[proc_rank] = tasks_sent * shunk_size;
    tasks_sent++;
  }

  if((RESOLUTION%(m_compSize * layers))!=0) {

    MPI_Recv(values, buffer_size, MPI_SHORT, MPI_ANY_SOURCE, MANDEL_TAG_DEEPTABLE, MPI_COMM_WORLD, &status);

    proc_rank = status.MPI_SOURCE;

    PrintMandel(proc_size_y[proc_rank], proc_start_y[proc_rank], values);

    m_pProgressDialog->MoveProgress();

    tasks_recvd++;

    info.y1 = y1 - ((double) (m_compSize * layers + 1) * dy);
    info.y2 = y2;
    info.size_y = RESOLUTION - (m_compSize * layers) * shunk_size;

    MPI_Send(&info,1, MandelInfoType, proc_rank, MANDEL_TAG_INFO, MPI_COMM_WORLD);

    proc_size_y[proc_rank] = info.size_y;
    proc_start_y[proc_rank] = m_compSize * layers * shunk_size;
    tasks_sent++;
  }


  while(tasks_sent!=tasks_recvd) {

    MPI_Recv(values, buffer_size, MPI_SHORT, MPI_ANY_SOURCE, MANDEL_TAG_DEEPTABLE, MPI_COMM_WORLD, &status);

    proc_rank = status.MPI_SOURCE;

    PrintMandel(proc_size_y[proc_rank], proc_start_y[proc_rank], values);

    m_pProgressDialog->MoveProgress();

    tasks_recvd++;
    
  } 

  free(values);

//----------------- Work Distribution and results gathering -----------

//  end_time = MPI_Wtime();
//  time_used.Format("Start time = %lf; End time = %lf",start_time, end_time);
//  ::MessageBox(NULL,time_used,"",0);

  m_pProgressDialog->DestroyWindow();
}

void CMandelAppDlg::PrintMandel(int y_size, int y_start, short *values)
{

  int layers = 1;

  int x_size = RESOLUTION;

  register int i,j;
  int aux;
  register BYTE Red,Green,Blue;

  int deep = DEEP;
  int phase_size = (deep/6) + 1;

//------------ Generates the color and sets the pixel -----------------

  for(j = 0; j<y_size; j++) {
    for(i = 0; i<x_size; i++) {
      aux = values[j * RESOLUTION + i]%deep;
      if(aux < (3*phase_size)) {
        if(aux > 85) {
          Red = 255 - ((aux-(2*phase_size)) * 255 / phase_size);
          Green = 255;
          Blue = 15;
        } else {
          if(aux > phase_size) {
            Red = 255;
            Green = (aux - phase_size)*255/phase_size;
            Blue = 15;
          } else {
            Red = aux*255/phase_size;
            Green = 15;
            Blue = 15;
          }
        }
      } else {
        if(aux < 4*phase_size) {
          Red = 15;
          Green = 255;
          Blue = (aux-(3*phase_size))*255/phase_size;
        } else {
          if(aux < 5*phase_size) {
            Red = 15;
            Green = 255 - ((aux-(4*phase_size)) * 255 / phase_size);
            Blue = 255;
          } else {
            Red = (aux-(5*phase_size))*255/phase_size;
            Green = (aux-(5*phase_size))*255/phase_size;
            Blue = 255;
          }
        }
      }
      if(m_pdcMemory->SetPixel(CPoint(i,y_start + j),RGB(Red,Green,Blue)) == 0) {
        ::MessageBox(NULL,"Error","",0); 
      }
    } // For i
  } //  For j

}

void MandelWorkerThread()
{

  MandelInfo info;
  MPI_Status status;
  short *deep_table;

  MPI_Recv(&info, 1, MandelInfoType, 0, MANDEL_TAG_INFO, MPI_COMM_WORLD, &status);
  
  while(!info.stop) {

    deep_table = (short *) calloc(info.size_x * info.size_y, sizeof(short));

//    ::MessageBox(NULL,"Start Rendering","",0);
    Mandel_Render(info, deep_table);

    MPI_Send(deep_table, info.size_x * info.size_y, MPI_SHORT, 0, MANDEL_TAG_DEEPTABLE, MPI_COMM_WORLD);

//    ::MessageBox(NULL,"Sent my info","",0);

    free(deep_table);

    MPI_Recv(&info, 1, MandelInfoType, 0, MANDEL_TAG_INFO, MPI_COMM_WORLD, &status);
  }

}



void CMandelAppDlg::OnOK() 
{
	// TODO: Add extra validation here
	
  MandelInfo info;

  info.stop = 1;

  for(int i=0;i < m_compSize; i++) {
    MPI_Send(&info,1, MandelInfoType, i, MANDEL_TAG_INFO, MPI_COMM_WORLD);
  }

	CDialog::OnOK();

  if(WaitForSingleObject(m_hworker_thread,2000) == WAIT_TIMEOUT) {
    TerminateThread(m_hworker_thread,0);
  }

  MPI_Finalize();
}


MPI_Datatype MandelInfoType;

void Mandel_SetupType
  (
  )
{

  int blockcounts[] = { 4, 3};
  MPI_Aint offsets[] = { 0, 4 * sizeof(double)};
  MPI_Datatype types[2];
  types[0] = MPI_DOUBLE;
  types[1] = MPI_INT;
  MPI_Type_struct(2, blockcounts, offsets, types, &MandelInfoType);
  MPI_Type_commit(&MandelInfoType);

}

void Mandel_Render
  (
    MandelInfo info,
    short *deep_table
  )
{
  double di = (info.y2 - info.y1) / info.size_y;
  double dr = (info.x2 - info.x1) / info.size_x;

  double ci = info.y1;
  double cr;

  int max_iters = DEEP;

  int y,x;

  for(y = 0; y < info.size_y; y++, (ci += di)) {
    cr = -info.x1;
    for(x = 0; x < info.size_x; x++, (cr -= dr)) {
      int iter;
      register double zr = 0, zi = 0;
      for(iter = max_iters; iter && (zr * zr + zi * zi < 4.0); iter--) {
        register double nr = zr * zr - zi * zi + cr;
        zi = zr * zi;
        zi += zi + ci;
        zr = nr;
      }
      deep_table[x + info.size_x * y] = iter;
    }
  }
}

CMandelAppDlg::~CMandelAppDlg()
{
  delete m_pBitmap;
  delete m_pdcMemory;
//  delete m_pProgressDialog;
}

void CMandelAppDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
}
