
#include "mandel.h"

void Mandel_Render
  (
    MandelInfo info,
    short *deep_table
  )
{
  register double di = (info.y2 - info.y1) / info.size_y;
  register double dr = (info.x2 - info.x1) / info.size_x;

  double ci = info.y1;
  double cr;

  int max_iters = DEEP;

  int y,x;

  for(y = 0; y < info.size_y; y++, (ci += di)) {
    cr = -info.x1;
    for(x = 0; x < info.size_x; x++, (cr -= dr)) {
      int iter;
      register double zr = 0, zi = 0;
      for(iter = max_iters; iter && (zr * zr + zi * zi < 4.0); iter--) {
        register double nr = zr * zr - zi * zi + cr;
        zi = zr * zi;
        zi += zi + ci;
        zr = nr;
      }
      deep_table[x + info.size_x * y] = iter;
    }
  }
}